'--------------------------------------------------------------------------
'File Name:	 MS_Hf_Install.vbs
'Author:	   Jigar Desai
'Purpose:	   To use common MS Hotfixes install file, for both CD and RSD
'Usage:     [CScript | WScript] MS_Hf_Install.vbs Deployment_Type Patch_label LogFileName
'           For Example, CScript MS_Hf_Install.vbs RSD April07_HF  C:\temp\MIApps_6.5.9.12.log 
'                    or  CScript MS_Hf_Install.vbs CD ALL  C:\temp\MIApps_6.5.9.13.log
'--------------------------------------------------------------------------

dim oShell, filesys
dim cmd, return_code, args, num
dim Deployment, Patch_label, LOGName 

set args = WScript.Arguments
num = args.Count

if num = 0 then
   WScript.Echo "Usage: [CScript | WScript] MS_Hf_Install.vbs Deployment_Type Patch_label"
   WScript.Echo "For Example, CScript MS_Hf_Install.vbs RSD ALL C:\temp\MI_MI016_07_R.log"
   WScript.Echo "For Example, CScript MS_Hf_Install.vbs CD ALL C:\temp\MI_MI016_07_R.log"
   WScript.Quit 1
end if

Deployment = args(0)
Patch_label = args(1)
LOGName = args(2)

Set oShell = CreateObject("WScript.Shell")
Set filesys = CreateObject("Scripting.FileSystemObject")

If filesys.FileExists(LOGName) Then
	Set logfile = filesys.OpenTextFile(LOGName, 8)
else
	Set logfile = filesys.CreateTextFile(LOGName, True)
end if

logfile.WriteLine(vbNewLine)
logfile.WriteLine(vbNewLine)
logfile.WriteLine(Date() & vbTab & Time())

'Install MS hotfixes

'Install September 2007 MS hotfixes
'There are no September2007 hotfixes

'Install October 2007 MS hotfixes

if Deployment = "CD" OR (Deployment = "RSD") then
  if  Deployment = "RSD" then
    logfile.WriteLine("This Microsoft Hotfix installation for " & Patch_label &" is done through Remote Software Distribution. Checking for Previous month's hotfixes on the system")
    logfile.WriteLine("Checking HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\HotFix\KB938127\Installed")
    If RegRead("HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" _
         & "\HotFix\KB938127\Installed") <> "1" Then
      logfile.WriteLine("This system does not have required MS hotfixes to install" & Patch_label)
      logfile.WriteLine("MS Hotfix installation will now abort.")
      Wscript.quit("1")
    End if
  End if
  logfile.WriteLine("Installing MS Hotfixes for October 2007")

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB933729")
  cmd = "MS07-058.WindowsXP-KB933729-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB933729 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB933729 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB933729")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB939653")
  cmd = "MS07-057.WindowsXP-KB939653-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB939653 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB939653 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB939653")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select


 logfile.WriteLine(vbTab & "Installing MS Hotfix KB941202")
  cmd = "MS07-056.WindowsXP-KB941202-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB941202 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB941202 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB941202")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select



  logfile.WriteLine("Finish installing MS Hotfixes for October 2007")



 'Install November 2007 MS hotfixes

 logfile.WriteLine("Installing MS Hotfixes for November 2007")

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB933360")
  cmd = "KB933360.2007TimeZoneUpdates-August.WindowsXP-KB933360-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB933360 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB933360 Installed successfully and reboot requires.")
	Case 1603
		logfile.WriteLine(vbTab & vbTab & "Updated Timezone patch is already installed on the system")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB933360")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB935448")
  cmd = "KB935448.RealtekHDACPErrAfterKB925902KB928843.WindowsXP-KB935448-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB935448 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB935448 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB935448")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select	



 logfile.WriteLine(vbTab & "Installing MS Hotfix KB943460")
  cmd = "MS07-061.WindowsXP-KB943460-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB943460 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB943460 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB943460")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 
  logfile.WriteLine("Finish installing MS Hotfixes for November 2007")



 'Install December 2007 MS hotfixes


  logfile.WriteLine("Installing MS Hotfixes for December 2007")

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB941568")
  cmd = "MS07-064.WindowsXP-KB941568-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB941568 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB941568 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB941568")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB944653")
  cmd = "MS07-067.WindowsXP-KB944653-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB944653 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB944653 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB944653")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select


 logfile.WriteLine(vbTab & "Installing MS Hotfix KB942763")
  cmd = "KB942763.WindowsXP-KB942763-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB942763 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB942763 Installed successfully and reboot requires.")
	Case 1603
		logfile.WriteLine(vbTab & vbTab & "Updated Timezone patch is already installed on the system")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB942763")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select


 logfile.WriteLine(vbTab & "Installing MS Hotfix KB941569")
  cmd = "MS07-068.WindowsXP-KB941569-x86-ENU.EXE /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB941569 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB941569 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB941569")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select



 logfile.WriteLine(vbTab & "Installing MS Hotfix KB942615")
  cmd = "MS07-069.WindowsXP-KB942615-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB942615 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB942615 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB942615")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 
  logfile.WriteLine("Finish installing MS Hotfixes for December 2007")


 'Install January 2008 MS hotfixes


  logfile.WriteLine("Installing MS Hotfixes for January 2008")

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB941644")
  cmd = "MS08-001.WindowsXP-KB941644-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB941644 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB941644 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB941644")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select


 logfile.WriteLine(vbTab & "Installing MS Hotfix KB943485")
  cmd = "MS08-002.WindowsXP-KB943485-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB943485 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB943485 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB943485")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 
  logfile.WriteLine("Finish installing MS Hotfixes for January 2008")



 'Install February 2008 MS hotfixes


  logfile.WriteLine("Installing MS Hotfixes for February 2008")

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB942831")
  cmd = "MS08-005.WindowsXP-KB942831-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB942831 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB942831 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB942831")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select


 logfile.WriteLine(vbTab & "Installing MS Hotfix KB942830")
  cmd = "MS08-006.WindowsXP-KB942830-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB942830 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB942830 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB943485")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB946026")
  cmd = "MS08-007.WindowsXP-KB946026-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB946026 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB946026 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB946026")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB943055")
  cmd = "MS08-008.WindowsXP-KB943055-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB943055 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB943055 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB943055")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB944533")
  cmd = "MS08-010.WindowsXP-KB944533-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB944533 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB944533 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB944533")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 
  logfile.WriteLine("Finish installing MS Hotfixes for February 2008")

end if



logfile.WriteLine("MS HotFix installation successfully finished on " & Date() & vbTab & Time())

Set oShell = Nothing
Set filesys = Nothing
Set logfile = Nothing
set args = Nothing
Wscript.quit("0")

Function RegRead(ByVal sRegValue)
      Set oShell = CreateObject("WScript.Shell")
      On Error Resume Next
      RegRead = oShell.RegRead(sRegValue)
      logfile.WriteLine(vbTab & vbTab & "Installed Value of " & sRegValue & " is: " & RegRead)
      ' If the value does not exist, error is raised
      If Err Then
        RegRead = ""
        Err.clear
      End If
      ' If a value is present but uninitialized the RegRead method
      ' returns the input value in Win2k.
      If VarType(RegRead) < vbArray Then
        If RegRead = sRegValue Then
          RegRead = ""
        End If
      End If
      On Error Goto 0
End Function
